#include <Bounce.h>
#include <Adafruit_NeoPixel.h>
#define PIN 23
int i;
int randR;
int randG;
int randB;
// cc values for inputs
int cc_off = 0;
int cc_on = 65;
int cc_super = 127;
int cc_start = 60;
int pot_curr = 0;
int pot_prev = 0;
Adafruit_NeoPixel strip = Adafruit_NeoPixel(9, PIN, NEO_GRB + NEO_KHZ800);

Bounce arcade_buttons[23]={
  Bounce(0,3),
  Bounce(1,3),
  Bounce(2,3), 
  Bounce(3,3),
  Bounce(4,3),
  Bounce(5,3),
  Bounce(6,3),
  Bounce(7,3),
  Bounce(8,3),
  Bounce(9,3),
  Bounce(10,3),
  Bounce(11,3),
  Bounce(12,3),
  Bounce(13,3),
  Bounce(14,3),
  Bounce(15,3),
  Bounce(16,3),
  Bounce(17,3),
  Bounce(18,3),
  Bounce(19,3),
  Bounce(20,3),
  Bounce(21,3),
  Bounce(22,3)
 
  };

int cc_values[23];
void setup() {
  initialize_midiPad();
  strip.begin();
  strip.show();
  colorWipe(strip.Color(0, 255, 0), 100); // Green
  colorWipe(strip.Color(0, 0, 0), 100); // 
  randomSeed(analogRead(5));
  
  }

void loop() {
  check_pot();
  for(i = 0; i<23; i++){
    arcade_buttons[i].update();
    }
  check_arcadeButtons();
  

}

void initialize_midiPad(){
  //setup CC values and arcade buttons on digital pins
  for(i = 0; i<23; i++){
    cc_values[i] = cc_start + i;
    pinMode(i, INPUT_PULLUP);
    }
  //setup Analog pin
  pinMode(39,INPUT_PULLUP);
  }

void check_arcadeButtons(){
  for(i = 0; i < 23; i++){
      if(arcade_buttons[i].fallingEdge()){
        usbMIDI.sendNoteOn(cc_values[i],99,3);
        randR = random(1,256);
        randG = random(1,256);
        randB = random(1,256);
        Serial.println(cc_values[i]);
        colorWipe(strip.Color(0,randG, randB),0);
        }

      if(arcade_buttons[i].risingEdge()){
        usbMIDI.sendNoteOff(cc_values[i],99,3);
        Serial.println("Off");
        colorWipe(strip.Color(0,0,0),0);
        }
    }
  
  }

void check_pot(){
  int analog_cc_value;
  int color;
  pot_curr = analogRead(0);
  if(abs(pot_curr - pot_prev) > 20){
      analog_cc_value = pot_curr/8;
      Serial.println( analog_cc_value);
      color = abs(127 - analog_cc_value);
      colorWipe(strip.Color(color,0,0),0);
      usbMIDI.sendControlChange(0,analog_cc_value,3);
      pot_prev = pot_curr;
    }
  }


  void colorWipe(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, c);
      strip.show();
      delay(wait);
  }
}

